<?php
if (!defined("MODULE_FILE")) die("Illegal File Access");
define("BLOCK_FILE", true);
define("FUNC_FILE", true);
require_once("config/config_global.php");
require_once("config/config_users.php");
require_once("function/mysql.php");
require_once("function/security.php");
if (file_exists("config/config_function.php")) require_once("config/config_function.php");
require_once("function/filters.php");
require_once("function/sources.php");

function is_user($user) {
	global $prefix, $db, $ip_check;
	static $usertrue;
	if (!isset($usertrue)) {
		$uid = intval($user[0]);
		$una = htmlspecialchars(substr($user[1], 0, 25));
		$pwd = htmlspecialchars(stripslashes($user[2]));
		$ip = getenv("REMOTE_ADDR");
		if ($uid != "" && $pwd != "") {
			if ($ip_check == "0") {
				list($pass) = $db->sql_fetchrow($db->sql_query("SELECT user_password FROM ".$prefix."_users WHERE user_id='$uid' AND user_name='$una'"));
				if ($pass == $pwd && $pass != "") {
					$usertrue = 1;
					return 1;
				}
			} else {
				list($pass, $last_ip) = $db->sql_fetchrow($db->sql_query("SELECT user_password, user_last_ip FROM ".$prefix."_users WHERE user_id='$uid' AND user_name='$una'"));
				if ($pass == $pwd && $pass != "" && $last_ip == $ip && $last_ip != "") {
					$usertrue = 1;
					return 1;
				}
			}
		}
		$usertrue = 0;
		return 0;
	}
	if ($usertrue == 1) {
		return 1;
	} else {
		return 0;
	}
}

function cookieset($setuid, $setusername, $setpass, $setstorynum, $setublockon, $settheme) {
	global $user_cookie_t;
	$info = base64_encode("$setuid:$setusername:$setpass:$setstorynum:$setublockon:$settheme");
	setcookie(USER_COOKIE, "$info", time() + intval($user_cookie_t));
}

function is_group($user, $name) {
	global $prefix, $db;
	if (is_user($user)) {
		$uid = intval($user[0]);
		list($points, $group) = $db->sql_fetchrow($db->sql_query("SELECT user_points, user_group FROM ".$prefix."_users WHERE user_id='$uid'"));
		list($mgroup, $grpoints, $grextra) = $db->sql_fetchrow($db->sql_query("SELECT m.mod_group, g.points, g.extra FROM ".$prefix."_modules AS m LEFT JOIN ".$prefix."_groups AS g ON (m.mod_group=g.id) WHERE m.title='$name'"));
		if (intval($group) && $group != "" && $group == $mgroup && $grextra == "1") {
			return 1;
		} elseif ((intval($points) && $points >= $grpoints) || $mgroup == 0) {
			return 1;
		}
	}
	return 0;
}

function update_points($id) {
    global $prefix, $db, $user, $update_points;
    if (intval($id) && is_user($user) && $update_points == 1) {
		$uid = intval($user[0]);
		list($rpoints) = $db->sql_fetchrow($db->sql_query("SELECT points FROM ".$prefix."_groups_points WHERE id='$id'"));
		$db->sql_query("UPDATE ".$prefix."_users SET user_points=user_points+".$rpoints." WHERE user_id='$uid'");
	}
}

function message_box() {
	global $user, $admin, $prefix, $multilingual, $currentlang, $db, $admin_file, $message_box;
	if ($message_box == 1) {
		$querylang = ($multilingual == 1) ? "AND (mlanguage='$currentlang' OR mlanguage='')" : "";
		$result = $db->sql_query("SELECT mid, title, content, expire, view FROM ".$prefix."_message WHERE active='1' $querylang");
		if ($numrows = $db->sql_numrows($result) > 0) {
			while (list($mid, $title, $content, $expire, $view) = $db->sql_fetchrow($result)) {
				$mid = intval($mid);
				$content = bb_decode($content);
				if ($title != "" && $content != "") {
					if ($expire == 0) {
						$remain = ""._UNLIMITED."";
					} else {
						$etime = intval(($expire - time()) / 3600);
						$etime_day = $etime / 24;
						$remain = ""._PURCHASED.": $etime "._HOURS." (".substr($etime_day, 0, 5)." "._DAYS.")";
					}
					$message_link = "- ".$remain." - <a href=\"".$admin_file.".php?op=editmsg&mid=$mid\">"._EDIT."</a> ]</center>";
					if ($view == 5) {
						OpenTable();
						messagebox($title, $content);
						if (is_admin($admin)) echo "<br /><br /><center>[ "._MVIEWSUBUSERS." ".$message_link."";
						CloseTable();
					} elseif ($view == 4 && is_admin($admin)) {
						OpenTable();
						messagebox($title, $content);
						echo "<br /><br /><center>[ "._MVIEWADMIN." ".$message_link."";
						CloseTable();
					} elseif (($view == 3 && is_user($user)) || ($view == 3 && is_user($user) && is_admin($admin))) {
						OpenTable();
						messagebox($title, $content);
						if (is_admin($admin)) echo "<br /><br /><center>[ "._MVIEWUSERS." ".$message_link."";
						CloseTable();
					} elseif (($view == 2 && !is_user($user)) || ($view == 2 && !is_user($user) && is_admin($admin))) {
						OpenTable();
						messagebox($title, $content);
						if (is_admin($admin)) echo "<br /><br /><center>[ "._MVIEWANON." ".$message_link."";
						CloseTable();
					} elseif ($view == 1) {
						OpenTable();
						messagebox($title, $content);
						if (is_admin($admin)) echo "<br /><br /><center>[ "._MVIEWALL." ".$message_link."";
						CloseTable();
					}
					if ($expire && $expire < time()) $db->sql_query("UPDATE ".$prefix."_message SET active='0', expire='0' WHERE mid='$mid'");
				}
			}
		}
	}
}

function getusrinfo($user) {
	global $userinfo, $prefix, $db;
	$uid = intval($user[0]);
	if (is_user($user) && $uid) {
		$userinfo = $db->sql_fetchrow($db->sql_query("SELECT * FROM ".$prefix."_users WHERE user_id='$uid'"));
		return $userinfo;
	}
}

function userblock() {
    global $user, $db, $prefix;
	$uid = intval($user[0]);
	$block = intval($user[4]);
    if ((is_user($user)) && ($block)) {
        list($userblock) = $db->sql_fetchrow($db->sql_query("SELECT user_block FROM ".$prefix."_users WHERE user_id='$uid'"));
		$userblock = bb_decode($userblock);
		themesidebox(""._MENUFOR."", $userblock);
    }
}

function public_message() {
	global $prefix, $db, $user, $p_msg, $broadcast_msg;
    if ($broadcast_msg == 1) {
		$uid = intval($user[0]);
		if (is_user($user) && $uid) {
			list($upref) = $db->sql_fetchrow($db->sql_query("SELECT user_broadcast FROM ".$prefix."_users WHERE user_id='$uid'"));
			if ($upref == 1) {
				$t_off = "<p align=\"right\">[ <a href=\"index.php?name=Account&op=edithome\">"._TURNOFFMSG."</a> ]</p>";
				$pm_show = 1;
			} else {
				$pm_show = 0;
			}
		} else {
			$t_off = "";
		}
		if (!is_user($user) || (is_user($user) && ($pm_show == 1))) {
			$c_mid = intval(addslashes(base64_decode($p_msg)));
			list($mid, $content, $tdate, $who) = $db->sql_fetchrow($db->sql_query("SELECT mid, content, date, who FROM ".$prefix."_public_messages WHERE mid > '$c_mid' ORDER BY date ASC LIMIT 1"));
			$mid = intval($mid);			
			$public_msg = "";
			if ((!isset($c_mid)) || ($c_mid = $mid)) {
				$public_msg .= "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\" class=\"bodyline\"><tr><td>\n";
				$public_msg .= "<center><font class=\"boxtitle\">"._BROADCASTFROM.": <a href=\"index.php?name=Account&op=info&uname=$who\">$who</font></a></center><br>$content<br>$t_off</td></tr></table>";
				$ref_date = $tdate+600;
				$actual_date = time();
				if ($actual_date >= $ref_date) {
					$public_msg = "";
					$numrows = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_public_messages"));
					if ($numrows == 1) {
						$db->sql_query("DELETE FROM ".$prefix."_public_messages");
						$mid = 0;
					} else {
						$db->sql_query("DELETE FROM ".$prefix."_public_messages WHERE mid='$mid'");
					}
				}
				if ($mid == 0 || $mid == "") {
					setcookie("p_msg");
				} else {
					$mid = addslashes(base64_encode($mid));
					setcookie("p_msg", $mid, time() + 600);
				}
			}
		}
    } else {
		$public_msg = "";
    }
	return $public_msg;
}

function get_theme() {
	global $user, $Default_Theme;
	if (is_user($user)) {
		$utheme = $user[5];
		if (file_exists("templates/$utheme") && $utheme != "") {
			$ThemeSel = $utheme;
		} else {
			$ThemeSel = $Default_Theme;
		}
    } else {
        $ThemeSel = $Default_Theme;
    }
    return $ThemeSel;
}
?>