<?php
if (!defined('MODULE_FILE')) {
	Header("Location: ../../index.php");
	exit;
}
$module_name = basename(dirname(__FILE__));
get_lang($module_name);
require_once("config/config_voting.php");
require_once("function/comments.php");

function all_poll() {
    global $prefix, $db, $multilingual, $currentlang, $pagenum, $module_name, $pagetitle, $defis, $pollnum;
	$querylang = ($multilingual == 1) ? "WHERE (planguage='$currentlang' OR planguage='') AND poll_date <= now()" : "WHERE poll_date <= now()";
	if ($pagenum == "") $pagenum = 1;
	$offset = ($pagenum-1) * $pollnum;
	$pagetitle = "$defis "._SURVEYS."";
    head();
    title(""._SURVEYS_LOGO."");
    OpenTable();
	$offset = intval($offset);
	$pollnum = intval($pollnum);
    $result = $db->sql_query("SELECT poll_id, UNIX_TIMESTAMP(poll_date) as formatted, poll_title, pool_vote, pool_comments, acomm FROM ".$prefix."_survey $querylang ORDER BY poll_id DESC LIMIT $offset, $pollnum");
    if ($db->sql_numrows($result) > 0) {
		$cn = 1;
		echo "<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"2\">";
		while (list($poll_id, $poll_date, $poll_title, $pool_vote, $pool_comments, $acomm) = $db->sql_fetchrow($result)) {
			$p_data = date("d.m.Y", $poll_date);
			$trcolor = ($cn == 2) ? "class=\"bgcolor2\"" : "";
			echo "<tr $trcolor><td>$p_data</td><td><a href=\"index.php?name=Voting&op=poll_show&poll_id=$poll_id\" title=\"$poll_title\"><img src=\"images/blocks/Voting.gif\" border=\"0\" alt=\"$poll_title\"></a></td><td><a href=\"index.php?name=Voting&op=poll_show&poll_id=$poll_id\" title=\"$poll_title\">$poll_title</a></td><td>"._SVOTES." ($pool_vote)";
			if ($acomm == 0) echo " "._SCOMM." ($pool_comments)";
			echo "</td></tr>";
			$cn++;
			if ($cn == 3) $cn = 1;
		}
		echo "</table>";
    } else {
		echo "<center><font class=\"option\">"._NOSURVEY."</font></center>";
    }
    CloseTable();
    list($numstories) = $db->sql_fetchrow($db->sql_query("SELECT Count(poll_id) FROM ".$prefix."_survey $querylang"));
	$numpages = ceil($numstories / $pollnum);
	num_page($module_name, $numstories, $numpages, $pollnum, "");
	foot();
}

function poll_save() {
    global $db, $prefix, $module_name, $voting_t;
    $poll_id = intval($_POST['poll_id']);
    $questions = intval($_POST['questions']);
	if ($poll_id) {
		head();
		title(""._SURVEYS_LOGO."");
		if (!$questions) {
			warning(""._SEROR1."", "?name=$module_name&op=poll_result&poll_id=$poll_id", 3, 1);
		} else {
			$voting_t = intval($voting_t);
			$ip = getenv("REMOTE_ADDR");
			$past = time() - $voting_t;
			$db->sql_query("DELETE FROM ".$prefix."_survey_check WHERE time < $past");
			$num_poll = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_survey_check WHERE (ip='$ip') AND (poll_id='$poll_id')"));
			if ($_COOKIE['Voting-'.$poll_id.''] == $poll_id || $num_poll > 0) {
				warning(""._SEROR2."", "?name=$module_name&op=poll_result&poll_id=$poll_id", 3, 1);
			} else {
				setcookie("Voting-".$poll_id."", $poll_id, time() + $voting_t);
				$ctime = time();
				$db->sql_query("INSERT INTO ".$prefix."_survey_check (ip, time, poll_id) VALUES ('$ip', '$ctime', '$poll_id')");
				$db->sql_query("UPDATE ".$prefix."_survey SET poll_answer_".$questions."=poll_answer_".$questions."+1, pool_vote=pool_vote+1 WHERE poll_id='$poll_id'");
				update_points(8);
				Header("Location: index.php?name=$module_name&op=poll_result&poll_id=$poll_id");
			}
		}
		foot();
	} else {
		Header("Location: index.php?name=".$module_name."");
	}
}

function poll_result($poll_id) {
    global $db, $prefix, $module_name, $ThemeSel, $pollcomm, $multilingual, $currentlang, $pagetitle, $defis;
	$querylang = ($multilingual == 1) ? "WHERE (planguage='$currentlang' OR planguage='')" : "";
    $poll_id = intval($poll_id);
    $result = $db->sql_query("SELECT * FROM ".$prefix."_survey WHERE poll_id='$poll_id' AND poll_date <= now()");
	if ($db->sql_numrows($result) > 0) {
		$row = $db->sql_fetchrow($result);
		$questions = explode("|", $row[poll_questions]);
		$p_summ = $row[pool_vote];
		$nm = 1;
		for ($i = 0; $i<count($questions)-1; $i++) {
			$a_ques[$i] = $questions[$i];
			$a_poll[$i] = $row[poll_answer_.$nm];
			$nm++;
		}
		$m_size = getimagesize("templates/$ThemeSel/images/mainbar.gif");
		$pagetitle = "$defis "._SURVEYS." $defis $row[poll_title]";
		head();
		title(""._SURVEYS_LOGO."");
		OpenTable();
		echo "<center><font class=\"option\">$row[poll_title]</font><br /><br />";
		echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"1\" width=\"100%\">";
		for ($i = 0; $i <count($questions)-1; $i++) {
			if ($p_summ > 0) {
				$proc = 100 * $a_poll[$i] / $p_summ;
				$im_w = (int)$proc - 10;
				$procent = number_format($proc, 2);
			} else {
				$im_w = 1;
				$procent = "0.00";
			}
			echo "<tr><td colspan=\"2\">$a_ques[$i] ($a_poll[$i])</td></tr>";
			echo "<tr><td width=\"90%\"><img src=\"templates/$ThemeSel/images/leftbar.gif\" alt=\"".$a_ques[$i]." - ".$procent."%\" title=\"".$a_ques[$i]." - ".$procent."%\"><img src=\"templates/$ThemeSel/images/mainbar.gif\" height=\"$m_size[1]\" width=\"".$im_w."%\" alt=\"".$a_ques[$i]." - ".$procent."%\" title=\"".$a_ques[$i]." - ".$procent."%\"><img src=\"templates/$ThemeSel/images/rightbar.gif\" alt=\"".$a_ques[$i]." - ".$procent."%\" title=\"".$a_ques[$i]." - ".$procent."%\"></td><td>".$procent."%</td></tr><tr><td height=\"5\"></td></tr>";
		}
		echo "</table><br />"._TOTALVOTES.": $p_summ";
		$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_survey $querylang"));
		if ($num > 1) echo "<br /><br />[ <a href=\"index.php?name=Voting\" title=\""._MOREPOLLS."\">"._MOREPOLLS."</a> ]";
		echo "</center>";
		CloseTable();
		if ($row['acomm'] == 0) ShowComments($poll_id);
		foot();
	} else {
		Header("Location: index.php?name=".$module_name."");
	}
}

function poll_show($poll_id) {
    global $db, $prefix, $module_name, $ThemeSel, $multilingual, $currentlang, $pagetitle, $defis;
	$poll_id = intval($poll_id);
	$result = $db->sql_query("SELECT poll_id, poll_title, poll_questions, pool_vote, pool_comments, acomm FROM ".$prefix."_survey WHERE poll_id='$poll_id' AND poll_date <= now()");
    if ($poll_id && $db->sql_numrows($result) > 0) {
		list($poll_id, $poll_title, $poll_questions, $pool_vote, $pool_comments, $acomm)= $db->sql_fetchrow($result);
		$pagetitle = "$defis "._SURVEYS." $defis $poll_title";
		head();
		title(""._SURVEYS_LOGO."");
		OpenTable();
		echo "<center><form action=\"index.php?name=Voting\" method=\"post\">";
		echo "<input type=\"hidden\" name=\"poll_id\" value=\"$poll_id\">";
		echo "<input type=\"hidden\" name=\"op\" value=\"poll_save\">";
		echo "<font class=\"option\">$poll_title</font><br /><br />";
		echo "<table border=\"0\">";
		$questions = explode("|", $poll_questions);
		for ($i = 0; $i < count($questions) - 1; $i++) {
			$n = $i + 1;
			echo "<tr><td valign=\"top\"><input type=\"radio\" name=\"questions\" value=\"".$n."\"></td><td><font class=\"content\">$questions[$i]</font></td></tr>\n";	
		}
		echo "</table><br><center><input type=\"submit\" value=\""._VOTE."\"></form><br>";
		echo "<br><font class=\"content\">[ <a href=\"index.php?name=Voting&op=poll_result&poll_id=$poll_id\" title=\""._RESULTS."\">"._RESULTS."</a> | <a href=\"index.php?name=Voting\" title=\""._POLLS."\">"._POLLS."</a> ]<br>";
		if ($acomm == 0) {
			echo "<br>"._VOTES.": $pool_vote<br>"._COMMENTS.": $pool_comments";
		} else {
			echo "<br>"._VOTES.": $pool_vote";
		}
		echo "</font></center>";
		CloseTable();
		foot();
	} else {
		Header("Location: index.php?name=".$module_name."");
	}
}

switch($op) {
	case"poll_result":
    poll_result($poll_id);
    break;
    
    case"poll_save":
    poll_save();
    break;
    
    case"poll_result":
    poll_result($poll_id);
    break;
    
    case "poll_show":
    poll_show($poll_id);
    break;

    default:
    all_poll();
    break;
}
?>